//------------------------------------------------------------------------------
// Lamp : Open source game middleware
// Copyright (C) 2004  Junpei Ohtani ( Email : junpee@users.sourceforge.jp )
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

/** @file
 * 数学のテストヘッダ
 * @author Junpee
 */

#ifndef MATH_TEST_H_
#define MATH_TEST_H_

#include <LampUnit/TestCase.h>

//------------------------------------------------------------------------------
/**
 * 数学のテスト
 */
class MathTest : public TestCase{
public:
	/**
	 * コンストラクタ
	 * @param name テストの名前
	 */
	explicit MathTest(String name) : TestCase("MathTest"){}

	/**
	 * テストを実行する
	 */
	virtual void runTest(){}

	/**
	 * テストスィートの取得
	 * @return テストスィート
	 */
	static Test* suite();

	// 定数テスト
	virtual void testFixedNumber();

	// 単位変換テスト
	virtual void testUnitChange();

	// 最大最小テスト
	virtual void testMaxMin();

	// 絶対値テスト
	virtual void testAbs();

	// 切り捨て切り上げテスト
	virtual void testFloorCeil();

	// 浮動小数値演算テスト
	virtual void testFloat();

	// 指数、対数テスト
	virtual void testExpLog();

	// 三角関数テスト
	virtual void testTrigonometricFunction();

private:

	// 大きなfloat値
	static float bigFloat_;

};

//------------------------------------------------------------------------------
#endif // End of MATH_TEST_H_
//------------------------------------------------------------------------------
